#property strict
//********************************************************************
#import "LV100_DLL.dll"
   int  af_CreateForm(string fname, int &af[]);
   void af_GetDataI(string &sn,double &bf[],int i);
//********************************************************************
#import "af_Data_dat_DLL.dll"
   int af_Data_dat1W(string &fname,int t1f,int t2f,int disf);
   int af_Data_dat2(double &data[],int size_dataf);
//********************************************************************
#import "af_TT1.ex4"
   void af_Graph_g(string _fname,string symb,int t1,int t2,int &oct_g[],double &bal_g[],int size_g);
   void af_Table3(string _fname,string &sfx[],double &res1[],int Row,int Col);
   string af_N(int ind, double y);
   double af_csd(string symbf);
   double af_MRG(string symbf,int mrg);
   //void af_TTi(double &arrd1[],int &arrd2[],int &ad[],int &bd[],double &hst[],int sizeh);
//********************************************************************
#import "af_FileBin1.dll"
   int af_FileOpenW(string fname,string type);
   int af_FileClose(int handle);
   
   string af_ReadLineW(int handle);
   void   af_WriteLineW(int handle, string s);
//********************************************************************
#import "user32.dll"
   //int RegisterWindowMessageW(string lpString);
   //int SendMessageW(int hWnd,int Msg,int wParam, uchar &lParam[]);
   int PostMessageW(int hWnd,int Msg,int wParam,int lParam);
#import
//********************************************************************
#include <TT\af_AutoX1.mqh>
//********************************************************************
string _fname="as_TT_S12-1a.dat";
//---------------------------------
double data[];
double par[11];
double x[];
double res[11];
double hst[];

int sizeh=0;
bool Graph=false;
bool Draw=false;
//--------------------
string symb;
//--------------------
int t1,t2;
bool AutoX=false;
int auto=0,write=0,tab=0;
//--------------------
int Opt=0,tc=0,dtc=0,dtcm=0;
double cnt=1; 
double xo[],ys[],st[],ye[];
int iRow,ix[],au[3];
double bal_m=-1000000;
string sf[],txt2,cnt_s;
//********************************************************************
int start() 
{
   if (af_LV1()<1) return(0);  
   
   symb=StringSubstr(Symbol(),0,6); 
   
   if (!Draw) ObjectsDeleteAll();  Comment("Process...");
   
   tc=int(TimeLocal());
   
   if (!af_Info()) return(0);
   //-------------------------------------------------------
   if (Opt>0) {if (!AutoX) af_Opt(); else af_Auto_X();} 
   else 
   {
      af_Trade(data,par,x,res); 
      txt2=af_txt2();
   }
   //================================================
   string txt="Count:  "+TimeToStr(TimeLocal()-tc,TIME_SECONDS)+"\n"+
   "TestData: "+TimeToStr(t1)+" - "+TimeToStr(t2)+"\n"+symb+"\n"+txt2;
   Comment(txt);
   //================================================
   if (!Opt && (Graph || Draw)) 
   {
      sizeh=int(res[1]+0.5); if (sizeh<=0) {Comment("sizeh=0!"); return(0);} 
      ArrayResize(hst,sizeh*7); af_hst(hst,sizeh);
      
      if (Draw) af_Draw();
      if (Graph) af_Graph();
   }
   //================================================
   return(0);
}
//********************************************************************
void af_Auto_X()
{
   double min[],stp[],max[];
   double yi[];
   int Row=au[1]; 
   
   ArrayResize(min,Opt);
   ArrayResize(stp,Opt);
   ArrayResize(max,Opt);
   ArrayResize(yi,Opt*Row);
   
   for (int i=0; i<Opt; i++)
   {
      min[i]=ys[i];
      stp[i]=st[i];
      max[i]=ye[i];
      x[ix[i]]=int((ys[i]+ye[i])/2/st[i])*st[i]; 
      yi[i]=x[ix[i]];
   }
   Comment(cnt_s,"\nAutoX...");
   
   if (auto==0) af_AutoX(min,stp,max,yi,au,Opt); 
   else 
   {
      au[0]=int(MathLog(cnt)*100);
      cnt_s=cnt_s+" / "+string(au[0]); 
      af_AutoX2(min,stp,max,yi,au,Opt);
   }
  
   int Col=6+iRow,j,jm=0; if (tab>0) Col=6+Opt;
   double Res[]; ArrayResize(Res,Row*Col);
   double bal,balm=-1000000; 
   
   for (int i=0; i<Row; i++)
   {
      for (j=0; j<Opt; j++)
         x[ix[j]]=yi[j+i*Opt];
      
      af_Trade(data,par,x,res);
      
      bal=res[0]; if (bal<0) res[3]=-1; if (bal>balm) {balm=bal; jm=i; txt2=af_txt2();}
      
      int k=i*Col;
      for (j=0; j<6; j++) Res[j+k]=res[j]; 
      if (tab==0) {for (j=0; j<iRow; j++) Res[j+6+k]=x[j];} else {for (j=0; j<Opt; j++) Res[j+6+k]=x[ix[j]];}
   }
   
   string sfx[]; if (tab==1) {ArrayResize(sfx,Opt); for (j=0; j<Opt; j++) sfx[j]=sf[ix[j]];} else {ArrayResize(sfx,iRow); for (j=0; j<iRow; j++) sfx[j]=sf[j];} 
   
   af_Table3(_fname,sfx,Res,Row,Col);
   
   if (write==0) {if (tab==0) for (j=0; j<iRow; j++) x[j]=Res[j+6+jm*Col]; else for (j=0; j<Opt; j++) x[ix[j]]=Res[j+6+jm*Col]; af_FileWrite();}
}
//********************************************************************
double af_Fit(double &y[],int Nj)
{
   for (int j=0; j<Nj; j++) x[ix[j]]=y[j];
            
   af_Trade(data,par,x,res);
   
   dtc=int(TimeLocal()-tc);
   
   if (res[0]>bal_m) {bal_m=res[0]; dtcm=dtc; Comment("Count:  ",TimeToStr(dtc,TIME_SECONDS)," / ",TimeToStr(dtcm,TIME_SECONDS),"\n",cnt_s,"\nAutoX...","\nbal=$",af_N(0,bal_m));} else
   if (dtc%60==0) Comment("Count:  ",TimeToStr(dtc,TIME_SECONDS)," / ",TimeToStr(dtcm,TIME_SECONDS),"\n",cnt_s,"\nAutoX...","\nbal=$",af_N(0,bal_m)); 
   
   return(res[0]);
}       
//********************************************************************
void af_Opt()
{
   int  Row=100,Col=6+iRow; if (tab>0) Col=6+Opt; 
   double Res[]; ArrayResize(Res,Row*Col);
   double bal,balm=-1000000; 
   int i,j,k,balm_p=0,jm=0;
   
   for (j=0; j<Opt; j++) x[ix[j]]=ys[j];
   
   i=0; xo[0]-=st[0]; int nn=0; 
   while(i<Opt && !IsStopped())
   {
      if (xo[i]+st[i]/2<ye[i]) {xo[i]+=st[i]; x[ix[i]]=xo[i]; i=0;} else {xo[i]=ys[i]; x[ix[i]]=xo[i]; i++; continue;} 
      
      af_Trade(data,par,x,res);
      
      bal=res[0]; if (bal>balm) {balm=bal; balm_p=int(res[4]); jm=nn; txt2=af_txt2();} if (bal<0) res[3]=-1; 
      
      k=nn*Col; 
      for (j=0; j<6; j++) Res[j+k]=res[j]; 
      if (tab==0) {for (j=0; j<iRow; j++) Res[j+6+k]=x[j];} else {for (j=0; j<Opt; j++) Res[j+6+k]=x[ix[j]];}
      nn++; 
      
      if (nn>Row-5) {Row+=100; ArrayResize(Res,Row*Col);}
      
      cnt--;
      Comment("Count:  ",TimeToStr(TimeLocal()-tc,TIME_SECONDS),"\n","cnt=",StringFormat("%.0f",cnt),"\nbal=",af_N(1,balm),"\nbal_p=",balm_p);
   }
   Row=nn; ArrayResize(Res,Row*Col); 
   
   string sfx[]; if (tab==1) {ArrayResize(sfx,Opt); for (j=0; j<Opt; j++) sfx[j]=sf[ix[j]];} else {ArrayResize(sfx,iRow); for (j=0; j<iRow; j++) sfx[j]=sf[j];} 
   
   af_Table3(_fname,sfx,Res,Row,Col);
   
   if (write==0) {if (tab==0) for (j=0; j<iRow; j++) x[j]=Res[j+6+jm*Col]; else for (j=0; j<Opt; j++) x[ix[j]]=Res[j+6+jm*Col]; af_FileWrite();}
}
//********************************************************************
string af_txt2()
{
   int nsd=int(res[1]+0.5); double mo=0; if (nsd!=0) mo=res[0]/nsd;
   string txt;
   txt=txt+StringConcatenate("bal_$="+af_N(0,res[0]),"   pf=",DoubleToStr(res[2],2),"   drd=",DoubleToStr(res[7],0),"   drd%=",DoubleToStr(res[3],2),
         "   nsd=",nsd,"   mo=$",DoubleToStr(mo,2),"   bal_p=",res[4],"   r2=",DoubleToStr(res[3],4)+"\n");
   for (int i=0; i<iRow; i++) 
   {
      if (StringSubstr(sf[i],0,2)=="HR" && x[i]>=24) txt=txt+sf[i]+"="+StringFormat("%g",x[i]-24)+"\n"; else
      txt=txt+sf[i]+"="+StringFormat("%g",x[i])+"\n";
   }
   return(txt);   
}
//********************************************************************
void af_Graph()
{
   int oct_g[]; ArrayResize(oct_g,sizeh+1); oct_g[0]=int(hst[3]); 
   double bal=0,bal_g[]; ArrayResize(bal_g,sizeh+1); bal_g[0]=0;  
   for (int i=0; i<sizeh; i++) {oct_g[i+1]=int(hst[3+i*7]); bal+=hst[6+i*7]; bal_g[i+1]=bal;}
   af_Graph_g(_fname,symb,t1,t2,oct_g,bal_g,sizeh+1); 
}
//********************************************************************
void af_Draw()
{
   int nd[4]={0,0,0,3}; for (int j=0; j<3; j++) nd[j]=int(res[j+8]);
   int size1=nd[0]*nd[1],size2=nd[2]*nd[3]; 
   if (size1==0 && size2==0) {Comment("Draw Arrays = 0!"); return;}  
   double arrd1[]; if (size1>0) ArrayResize(arrd1,size1);
   int    arrd2[]; if (size2>0) ArrayResize(arrd2,size2);
   af_arrd(arrd1,arrd2,nd); 
   
   int wd[]={clrRed,0,2, clrDeepSkyBlue,0,0, clrDeepSkyBlue,0,0};
   
   int Nd=int(res[9])-1; if (ArraySize(wd)/3<Nd) {MessageBox("Draw Arrays < Nd!"); return;}
   
   af_TTi(arrd1,arrd2,nd,wd,hst,sizeh);
}
//********************************************************************
void af_TTi(double &arrd1[],int &arrd2[],int &nd[],int &wd[],double &hstf[],int sizehf) 
{
   int sized1=nd[0];
   int nd1=nd[1];
   
   int sized2=nd[2];
   int nd2=nd[3];
   
   if (sized1==0 && sized2==0 && sizehf==0) {Comment("af_TT1_i -> All Draw Arrays = 0!"); return;}
   
   int handle=FileOpen("TT1-i.dat",FILE_BIN|FILE_WRITE);
   if (handle<1) {Comment("FileNotOpen!"); return;}
   
   FileWriteInteger(handle,nd1);
   FileWriteInteger(handle,sized1);
   
   if (sized1>0) 
   {
      FileWriteArray(handle,arrd1,0,sized1*nd1);
      FileWriteArray(handle,wd,0,nd1*3);
   }
   
   FileWriteInteger(handle,7);
   FileWriteInteger(handle,sizehf);
   if (sizehf>0) FileWriteArray(handle,hstf,0,sizehf*7);
   
   FileWriteInteger(handle,nd2);
   FileWriteInteger(handle,sized2);
   if (sized2>0) FileWriteArray(handle,arrd2,0,sized2*nd2);
   
   long id = ChartID(); 
   string txt=ChartGetString(id,CHART_COMMENT);
   int len=StringLen(txt);
   
   FileWriteInteger(handle,len); 
   FileWriteString(handle,txt,len); 
   
   FileClose(handle);
   //-----------------------------------------
   bool resi=ChartSaveTemplate(id,"TT1-i");
   
   if (!resi) MessageBox("Not Res!");
   //------------------------------------------------
   string fname = TerminalPath()+"\\templates\\TT1-i.tpl";
   
   handle = af_FileOpenW(fname,"r");
   if (handle<1) {Comment("File Not Open!"); return;}
   
   string s1,s[];
   int Ns=100; ArrayResize(s,Ns);
   
   int nn=0;
   while(!IsStopped())
   {
      s1=af_ReadLineW(handle); 
      s[nn]=s1;
      nn++;
      if (nn>Ns-5) {Ns+=100; ArrayResize(s,Ns);}
      if (s1=="</indicator>") break;
   }
   af_FileClose(handle);
   
   Ns=nn; ArrayResize(s,Ns);
   //------------------------------------------------
   handle = af_FileOpenW(fname,"w");
   
   for (int i=0; i<Ns; i++)
      af_WriteLineW(handle,s[i]); 
      
   af_WriteLineW(handle,"<indicator>");
   af_WriteLineW(handle,"name=Custom Indicator");
   af_WriteLineW(handle,"<expert>");
   af_WriteLineW(handle,"name=_TT/TT1-i");
   af_WriteLineW(handle,"</expert>");
   af_WriteLineW(handle,"</indicator>");
   af_WriteLineW(handle,"</window>");
   af_WriteLineW(handle,"</chart>");
      
   af_FileClose(handle);
   //------------------------------------------------
   resi=ChartApplyTemplate(id,"TT1-i.tpl");
   //ChartRedraw();
}
//********************************************************************
bool af_Info()
{
   if (t1>=t2 ) {Comment(symb,"  t1>=t2 return"); return(0);}
   //--------------------------------------------------------
   int handle=FileOpenHistory("serv.txt",FILE_CSV|FILE_READ|FILE_ANSI,';');
   int HRd=0; if (handle<1) {MessageBox("File Serv Not Open!"); return(0);}
   string srv="",serv=""; srv=FileReadString(handle); serv=FileReadString(handle); FileClose(handle);  
   if ((srv!="FXO" && srv!="ATC") || serv=="") {MessageBox("Not serv!"); return(0);}  
   //--------------------------------------------------------
   string fn = TerminalPath()+"\\history\\"+serv+"\\"+symb+"1.dat"; 
   int size_data=af_Data_dat1W(fn,t1,t2,1440*12);
   if (size_data>6) ArrayResize(data,size_data*7);
   if (af_Data_dat2(data,size_data)<1) {Comment("Err af_Data_dat !"); return(0);}
   
   double point  = MarketInfo(symb,MODE_POINT); 
   int    digits = int(MarketInfo(symb,MODE_DIGITS)); 
   double csd    = MarketInfo(symb,16); 
   
   if (csd==0) csd=af_csd(symb); if (csd==0) {Comment("csd=0!"); return(0);}
   
   double MRG=af_MRG(symb,500);
   
   if (symb=="XAUUSD") {point=0.01; digits=2;}
  
   double com=8,depo=10000; 
   if (srv=="ATC") {com=12; if (symb=="EURUSD" || symb=="GBPUSD" || symb=="USDJPY" || symb=="USDCHF" || symb=="AUDUSD" || symb=="EURJPY" || symb=="GBPYPY") com=8;}
   
   par[0]=size_data;
   par[1]=t1;
   par[2]=point;
   par[3]=digits;
   par[4]=csd;
   par[5]=com;
   par[6]=depo;
   par[7]=MRG;
   par[8]=HRd;
   par[9]=Graph;
   par[10]=Draw;
   
   return(true);
}
//********************************************************************
void af_FileWrite()
{   
   if (write!=0) return;
   int handle=FileOpen(_fname,FILE_BIN|FILE_READ|FILE_WRITE);
   if (handle<1) return;
   FileSeek(handle,12,SEEK_SET);
   double y;
   for (int i=0; i<iRow; i++) 
   {
      FileSeek(handle,4+12,SEEK_CUR);
      y=FileReadDouble(handle);
      if (y!=x[i])
      {
         FileSeek(handle,-8,SEEK_CUR);
         FileWriteDouble(handle,x[i]);
      }
      FileSeek(handle,3*8,SEEK_CUR);
   }
   FileClose(handle);
}
//********************************************************************
int af_LV1()
{
   string fn = TerminalPath()+"\\MQL4\\Files\\"+_fname;
   
   int af[5]; bool fres=af_CreateForm(fn,af); if (!fres) return(0);
   int Row=af[1],Col=af[2]; t1=af[3]; t2=af[4];
   double bf[]; ArrayResize(bf,Row*Col); ArrayResize(sf,Row);
   
   for (int i=0; i<Row; i++) {sf[i]=""; af_GetDataI(sf[i],bf,i);}
   
   iRow=Row-3; 
   ArrayResize(x,iRow);
   
   Opt=0; 
   for (int i=0; i<iRow; i++) 
	{
      x[i]=bf[1+i*Col];
      if (bf[0+i*Col]>0.5) Opt++;
   }
   
   AutoX = bf[0+(Row-3)*Col]; auto=int(bf[1+(Row-3)*Col]); au[0]=int(bf[2+(Row-3)*Col]); au[1]=int(bf[3+(Row-3)*Col]); au[2]=int(bf[4+(Row-3)*Col]); 
   Graph = bf[0+(Row-2)*Col]; write=int(bf[1+(Row-2)*Col]); tab=int(bf[2+(Row-2)*Col]); 
   Draw  = bf[0+(Row-1)*Col];
   
	if (Graph>0 || Draw>0) {Opt=0; AutoX=0; return(1);}
	
	ArrayResize(ix,Opt);
	ArrayResize(xo,Opt);
	ArrayResize(ys,Opt);
   ArrayResize(st,Opt);
   ArrayResize(ye,Opt);
   
   Opt=0;
   for (int i=0; i<iRow; i++)
   {
      if (bf[0+i*Col]<0.5) continue;
      ix[Opt]=i;
      ys[Opt]=bf[2+i*Col];
      st[Opt]=bf[3+i*Col]; 
      ye[Opt]=bf[4+i*Col];
      if (StringSubstr(sf[i],0,2)=="HR") if (ye[Opt]<ys[Opt]) ye[Opt]+=24;
      Opt++;
   }
      
   int err=0; cnt=1;    
   for (int i=0; i<Opt; i++)
   {   
      if (st[i]==0) {err=1; break;}
      if ((ye[i]-ys[i])/st[i]<=0) {err=1; break;}
      xo[i]=ys[i];
      cnt*=MathRound((ye[i]-ys[i])/st[i])+1;
   }
   if (err==1) {MessageBox("Error from parameters!"); return(0);}
   
   cnt_s="cnt="+StringFormat("%.0f",cnt);  
   
   if (AutoX>0 && cnt>0 && cnt<2000) AutoX=0; 
   
   return(1);
}
//********************************************************************
//---------------------------------------------------------------------------
double hst_g[];
double arrd1_g[];
int arrd2_g[];
//---------------------------------------------------------------------------
void af_Trade(double &data_g[],double &par_g[],double &x_g[],double &res_g[]) 
{
	int    n=0;
	double hrma=x_g[n]; n++;
	double kabs=x_g[n]; n++;
	int    type=int(x_g[n]); n++;
	double HRs=x_g[n]; n++;
	double HRe=x_g[n]; n++;
	double TP=int(x_g[n]/0.1)*0.1; n++;
	int    SL=int(x_g[n]); n++;
	int    FE=int(x_g[n]); n++;
	int    BS=int(x_g[n]); n++;
	int    FRI=int(x_g[n]); n++;
	double Risk=x_g[n];
	//----------------------------------------------
	int size_data=int(par_g[0]);
	int    t1f=int(par_g[1]);
	double point=par_g[2];
	int    digits=int(par_g[3]);
	double csd=par_g[4];
	double com=par_g[5];
	double depo=par_g[6];
	double MRG=par_g[7];
	int    HRd=int(par_g[8]);

	bool  Graph_g=false; if (int(par_g[9])>0) Graph_g=true;
	bool  Draw_g=false; if (int(par_g[10])>0) Draw_g=true;
	//----------------------------------------------
	int t=0;
	int o_bid=1;
	int h_bid=2;
	int l_bid=3;
	int o_ask=4;
	int h_ask=5;
	int l_ask=6;
	//----------------------------------------------
	double ss=0,sH=0,sL=0;
	double ci=0,cii=0,dca=0,abs=0,kii=0;
	double z=0,zd=0,z3=0,a1=0,ki=0,ki3=0;
	//----------------------------------------------
	double oop1=0,oop2=0,ocp1=0,ocp2=0,ls1=0,ls2=0;
	double otp1=0,otp2=0,osl1=0,osl2=0,uib=0,uis=0;
	int ot1=0,ot2=0,oot1=0,oot2=0,oct1=0,oct2=0,fss1=0,fss2=0;

	double SS1=0,SS2=0,TP1=0,TP2=0;
	double ask_o=0,bid_o=0,ask_h=0,bid_l=0,ask_l=0,bid_h=0;
	double po=0.5*point,mrg=0,pct=0,ls=0;
	double sum1=0,sum2=0,sum3=0;
   int ti=0,tip=0,tid=0,ft=0,ftp=0,fte=0,ftep=0;
	int fc=0,FB1=0,FS1=0,oopi=0,ocpi=0,nn=0,out=0;
   //----------------------------------------------
	double sx=0,sy=0,sxy=0,sxx=0,syy=0,r2=-1;

	double maxpeak=depo;
	double minpeak=depo;
	double balance=depo;
	double drd_pctm=0;
	double drdm=0;
	double drd=0;
	double drd_pct=0;
   //----------------------------------------------
	int dti=0,dtd=86400;
	int hrs=int(HRs*3600+0.5); if (hrs>dtd) hrs-=dtd; 
	int hre=int(HRe*3600+0.5); if (hre>dtd) hre-=dtd;
	int td=HRd*3600;  
	int dtw=7*dtd,dtw0=3*dtd,tiw=0,tdw=0;
	//-------------------------------------------------------
	int sizeh_g=0,nnd1=0,sized1=0,nd1=0,nnd2=0,sized2=0,nd2=3;
	if (Graph_g || Draw_g) {sizeh_g=1000; ArrayResize(hst_g,sizeh_g*7);}
	if (Draw_g) 
	{
	   sized1=10000; nd1=4; ArrayResize(arrd1_g,sized1*nd1);
	   sized2=1000;  nd2=3; ArrayResize(arrd2_g,sized2*nd2); 
	}
   //-------------------------------------------------------
	int    pro_p=0;
	double pro=0;
	int    bal_p=0;
	double bal=0;
	double sli=SL*point*10; if (sli<0) sli=-sli;
	double tpi=TP*point*10; if (tpi<0) tpi=-tpi;
	double dii=10*point;
	double Lots=1; 
	//-------------------------------------------------------
	int cbi=size_data-1;

	bid_o=data_g[o_bid+cbi*7];
	ask_o=data_g[o_ask+cbi*7];

	ci=(ask_o+bid_o)/2;

	ki=2.0/(hrma*60.0+1);
	ki3=2.0/(5*hrma*60.0+1); 
	z=ci; zd=0; z3=0; a1=ci; 
	if (type==1 || type==2) ki*=0.6; else if (type==3) ki*=2.7;
   
	cbi--;
	//================================================================
	for (int i=cbi; i>=0; i--)
	{
		tip=ti; ti=int(data_g[t+i*7]);

		bid_o=data_g[o_bid+i*7];
	   ask_o=data_g[o_ask+i*7];
		
		bid_h=data_g[h_bid+(i+1)*7];
		ask_l=data_g[l_ask+(i+1)*7];
		//===================================================
      if (ot1+ot2>0)
      {
         fss1=0; fss2=0; 
		   //---------------------------------
   		bid_l=data_g[l_bid+(i+1)*7];
		   ask_h=data_g[h_ask+(i+1)*7];
   		
   		if (ot1==1) {if (otp1>po && bid_h>otp1+po) {fss1=1; ocp1=otp1; oct1=tip; ot1=0;} else if (osl1>po && bid_l<osl1-po) {fss1=1; ocp1=osl1; oct1=tip; ot1=0;}}   
   		if (ot2==2) {if (otp2>po && ask_l<otp2-po) {fss2=2; ocp2=otp2; oct2=tip; ot2=0;} else if (osl2>po && ask_h>osl2+po) {fss2=2; ocp2=osl2; oct2=tip; ot2=0;}}
   		
   		if (ot1==3) if (ask_l<oop1-po && tip!=oot1) {ot1=1; oot1=tip;}
   		if (ot2==4) if (bid_h>oop2+po && tip!=oot2) {ot2=2; oot2=tip;}
   		
   		if (ot1==1) {mrg=ls1*MRG; pro=((bid_h-oop1)/point*csd-com)*ls1; if (mrg!=0) {pct=(balance+pro)/mrg*100; if (pct<100) out=1;}}
   		if (ot2==2) {mrg=ls2*MRG; pro=((oop2-ask_l)/point*csd-com)*ls2; if (mrg!=0) {pct=(balance+pro)/mrg*100; if (pct<100) out=1;}}   
		   //---------------------------------
   		bid_l=bid_o;
		   ask_h=ask_o;
   		
   		if (ot1==1) {if (otp1>po && bid_o>otp1+po) {fss1=1; ocp1=otp1; oct1=ti; ot1=0;} else if (osl1>po && bid_l<osl1-po) {fss1=1; ocp1=osl1; oct1=ti; ot1=0;}}   
   		if (ot2==2) {if (otp2>po && ask_o<otp2-po) {fss2=2; ocp2=otp2; oct2=ti; ot2=0;} else if (osl2>po && ask_h>osl2+po) {fss2=2; ocp2=osl2; oct2=ti; ot2=0;}}
   		
   		if (ot1==3) if (ask_o<oop1-po) {ot1=1; oot1=ti;}
   		if (ot2==4) if (bid_o>oop2+po) {ot2=2; oot2=ti;}
   		
   		if (ot1==1) {mrg=ls1*MRG; pro=((bid_o-oop1)/point*csd-com)*ls1; if (mrg!=0) {pct=(balance+pro)/mrg*100; if (pct<100) out=1;}}
   		if (ot2==2) {mrg=ls2*MRG; pro=((oop2-ask_o)/point*csd-com)*ls2; if (mrg!=0) {pct=(balance+pro)/mrg*100; if (pct<100) out=1;}}  
   	   //--------------------------------------
   	   if (i==0 || out==1)
   	   {
   	      if (ot1==1) {fss1=1; ocp1=bid_o; oct1=ti; ot1=0;}
   	      if (ot2==2) {fss2=2; ocp2=ask_o; oct2=ti; ot2=0;}
   	   }
   	   //--------------------------------------
      	if (fss1>0)
   		{
   			ocpi=int(0.5+ocp1/point); oopi=int(0.5+oop1/point); pro_p=ocpi-oopi; 
   
   			bal_p+=pro_p; pro=(pro_p*csd-com)*ls1; bal+=pro; balance+=pro; if (SL>0) if (pro_p<-(SL-1)*10) fc=1;
   
   			if (maxpeak<balance)
   			{
   				drd=maxpeak-minpeak;
   				if (maxpeak!=0.0 && drd!=0.0) {drd_pct=drd/maxpeak*100.0; if (drd_pctm<drd_pct) {drd_pctm=drd_pct; drdm=drd;}}
   				maxpeak=balance; minpeak=balance;
   			}
   			if (minpeak>balance) minpeak=balance;
   
   			if (pro>0) sum1+=pro;
   			if (pro<0) sum2-=pro;
   
   			sx+=nn; sy+=bal; sxy+=nn*bal; sxx+=nn*nn; syy+=bal*bal;
   
   			if (Graph_g || Draw_g)
   			{
   				hst_g[0+nn*7]=fss1; 
   				hst_g[1+nn*7]=oot1; 
   				hst_g[2+nn*7]=oop1; 
   				hst_g[3+nn*7]=oct1; 
   				hst_g[4+nn*7]=ocp1;
   				hst_g[5+nn*7]=ls1; 
   				hst_g[6+nn*7]=pro; 
   				
   				if (Graph_g) sum3+=pro_p;
   
   				if (nn>sizeh_g-5) {sizeh_g+=1000; ArrayResize(hst_g,sizeh_g*7);}
   			}
   
   			oop1=0; oot1=0; ocp1=0; oct1=0; otp1=0; osl1=0; ls1=0; nn++;
   		}
   	   //--------------------------------------
      	if (fss2>0)
   		{
   			ocpi=int(0.5+ocp2/point); oopi=int(0.5+oop2/point); pro_p=oopi-ocpi; 
   
   			bal_p+=pro_p; pro=(pro_p*csd-com)*ls2; bal+=pro; balance+=pro; if (SL>0) if (pro_p<-(SL-1)*10) fc=2;
   
   			if (maxpeak<balance)
   			{
   				drd=maxpeak-minpeak;
   				if (maxpeak!=0.0 && drd!=0.0) {drd_pct=drd/maxpeak*100.0; if (drd_pctm<drd_pct) {drd_pctm=drd_pct; drdm=drd;}}
   				maxpeak=balance; minpeak=balance;
   			}
   			if (minpeak>balance) minpeak=balance;
   
   			if (pro>0) sum1+=pro;
   			if (pro<0) sum2-=pro;
   
   			sx+=nn; sy+=bal; sxy+=nn*bal; sxx+=nn*nn; syy+=bal*bal;
   
   			if (Graph_g || Draw_g)
   			{
   				hst_g[0+nn*7]=fss2; 
   				hst_g[1+nn*7]=oot2; 
   				hst_g[2+nn*7]=oop2; 
   				hst_g[3+nn*7]=oct2; 
   				hst_g[4+nn*7]=ocp2;
   				hst_g[5+nn*7]=ls2; 
   				hst_g[6+nn*7]=pro; 
   				
   				if (Graph_g) sum3+=pro_p;
   
   				if (nn>sizeh_g-5) {sizeh_g+=1000; ArrayResize(hst_g,sizeh_g*7);}
   			}
   
   			oop2=0; oot2=0; ocp2=0; oct2=0; otp2=0; osl2=0; ls2=0; nn++;
   		}
   		//--------------------------------------
   		if (out==1) break;
      }
		//===================================================
		ci=(ask_o+bid_o)/2;

		if (type<3)
      {
   		kii=ki;
   		if (type>0)
   		{
      		dca=ci-z; if (dca<0) dca=-dca; if (type==2) dca*=dca; zd+=(dca-zd)*ki/4;
      		if (zd!=0) {kii=ki*dca/zd; if (kii>1) kii=1;}
         }
   		z+=(ci-z)*kii;
      }
      else
      if (type==3)
      {
         a1+=(ci-a1)*ki;
         z+=(a1-z)*ki;
      }
      cii=ci-z; if (cii<0) cii=-cii;
		z3+=(cii-z3)*ki3;

		abs=z3*kabs;

		ss=int(z/point+0.5)*point;
		sH=int((z+abs)/point+0.5)*point;
		sL=int((z-abs)/point+0.5)*point;
		//--------------------------------------
		if (ti-td<t1f) continue;
		//--------------------------------------
		if (hrs!=hre)
		{
			tid=ti-td; ftp=ft; ft=0; dti=tid-tid/dtd*dtd; 
   
         if (hre>hrs) {if (dti>=hrs && dti<hre) ft=1;} else if (dti>=hrs || dti<hre) ft=1;
   
         if (ft==1 && FRI!=1)
         {
            tiw=tid-dtw0; tdw=(tiw-tiw/dtw*dtw)/dtd;
   
            if (FRI==2) {if ((tdw==5 && dti>=18*3600) || tdw==0 || (tdw==1 && dti<5*60)) ft=0;} else
            if (FRI==0) {if ((tdw==5 && dti>=18*3600) || tdw==0 || (tdw==1 && dti<6*3600)) ft=0;}
         }
      }
		else {ft=1; ftp=1;}
      //===================================================
		if (Draw_g)
		{
			if (ft>ftp) {arrd2_g[0+nnd2*nd2]=ti; arrd2_g[1+nnd2*nd2]=1; arrd2_g[2+nnd2*nd2]=0; nnd2++;} else
			if (ft<ftp) {arrd2_g[0+nnd2*nd2]=ti; arrd2_g[1+nnd2*nd2]=2; arrd2_g[2+nnd2*nd2]=0; nnd2++;} 
			
			if (fte<ftep) if (sum3!=0) {arrd2_g[0+nnd2*nd2]=ti; arrd2_g[1+nnd2*nd2]=4; arrd2_g[2+nnd2*nd2]=int(sum3); sum3=0; nnd2++;} 
   		      
			if (nnd2>sized2-5) {ArrayResize(arrd2_g,(sized2+1000)*nd2); sized2+=1000;}

			arrd1_g[0+nnd1*nd1]=ti;
			
			arrd1_g[1+nnd1*nd1]=ss;
			arrd1_g[2+nnd1*nd1]=sH;
			arrd1_g[3+nnd1*nd1]=sL;

			if (nnd1>sized1-5) {ArrayResize(arrd1_g, (sized1+10000)*nd1); sized1+=10000;}

         nnd1++;
		}
		//===================================================
		ftep=fte; if (ft==1) fte=1;
		if (fte==0) continue;
		//===================================================
		SS1=sL; SS2=sH; TP1=sH; TP2=sL;
		//===================================================
		uib=0; uis=0;
		if (ot1==1) uib=oop1+dii;
		if (ot2==2) uis=oop2-dii;
		//--------------------------------------
		if (TP!=0)
		{ 
			if (uib>dii) {TP1=uib+tpi; if (TP>0 && sH>TP1) TP1=sH; if (SS2<TP1) SS2=TP1;} 
		   if (uis>dii) {TP2=uis-tpi; if (TP>0 && sL<TP2) TP2=sL; if (SS1>TP2) SS1=TP2;}
		}  
		//--------------------------------------
		if (ft==0)
		{
			if (ot1==3) {ot1=0; oop1=0; oot1=0; ls1=0;}
			if (ot2==4) {ot2=0; oop2=0; oot2=0; ls2=0;}

			if (FE>0)
			{
				if (FE==1) {TP1=ss; TP2=ss;}
				else
				if (FE==2)
				{
					TP1=ss; if (uib<TP1) TP1=uib;
					TP2=ss; if (uis>TP2) TP2=uis;
				}
				else
				if (FE==3)
				{
					TP1=sH; if (uib<TP1) TP1=uib;
					TP2=sL; if (uis>TP2) TP2=uis;
				}
				else
				if (FE==4) {TP1=uib; TP2=uis;}
			}
		}
		//--------------------------------------
		if (ot1==3) {oop1=SS1; if (ask_o<oop1-po) oop1=ask_o; if (osl1>po) {osl1=oop1-sli; if (bid_o<osl1-po) osl1=bid_o;}}
		if (ot2==4) {oop2=SS2; if (bid_o>oop2+po) oop2=bid_o; if (osl2>po) {osl2=oop2+sli; if (ask_o>osl2+po) osl1=ask_o;}}

		if (ot1==1 || ot1==3) if (otp1>po) {otp1=TP1; if (bid_o>otp1+po) otp1=bid_o;}
		if (ot2==2 || ot2==4) if (otp2>po) {otp2=TP2; if (ask_o<otp2-po) otp2=ask_o;}
		//-------------------------------------
		if (fc>0)
		{
			if (fc==1 && (ci>sH || ot2==2)) fc=0;
			if (fc==2 && (ci<sL || ot1==1)) fc=0;
		}
		//===================================================
		if (ft==0) {if (ot1==0 && ot2==0) {fte=0; fc=0;} continue;}
		//===================================================
		if (ot1>0 && ot2>0) continue;
		//--------------------------------------
		FB1=1; FS1=1;
		//--------------------------------------
		if (BS>0) {if (BS==1) FS1=0; else if (BS==2) FB1=0;}
		//--------------------------------------
		if (fc==1) FB1=0; else
		if (fc==2) FS1=0;
		//--------------------------------------
		if (ot1>0) FB1=0;
		if (ot2>0) FS1=0;
		//--------------------------------------
		if (FB1==0 && FS1==0) continue;
		//--------------------------------------
		if (TP>0) if (uib>dii && SS2<TP1) SS2=TP1; 
		if (TP>0) if (uis>dii && SS1>TP2) SS1=TP2;
		//--------------------------------------
      if (Risk==0) {Lots=1; ls=Lots;} else {Lots=0.01; ls=ulong(0.01*Risk*balance/1000/Lots)*Lots;}
      if (ls<Lots || (ls*1000+ls*MRG)>balance) {out=1; break;}   
      //--------------------------------------
		if (FB1==1) {oop1=SS1; if (ask_o<oop1) oop1=ask_o; oot1=ti; ot1=3; ls1=ls; if (SL>0) {osl1=oop1-sli; if (bid_o<osl1-po) osl1=bid_o;} otp1=TP1; if (bid_o>otp1+po) otp1=bid_o;}
		if (FS1==1) {oop2=SS2; if (bid_o>oop2) oop2=bid_o; oot2=ti; ot2=4; ls2=ls; if (SL>0) {osl2=oop2+sli; if (ask_o>osl2+po) osl1=ask_o;} otp2=TP2; if (ask_o<otp2-po) otp2=ask_o;}
		//--------------------------------------
	}
   //=================================================================
	drd=maxpeak-minpeak;
	if (maxpeak!=0.0) {drd_pct=drd/maxpeak*100.0; if (drd_pctm<drd_pct) {drd_pctm=drd_pct; drdm=drd;}}
	drd_pct=drd_pctm;
	drd=drdm;

	double pf=0; if (sum2!=0) pf=sum1/sum2;

	if (nn>1)
	{
		double aa=(sx*sy-nn*sxy)/(sx*sx-nn*sxx);
		double bb=(sy-aa*sx)/nn;

		double ssy=syy-aa*sxy-bb*sy;
		double ssx=syy-sy*sy/nn;

		if (ssx!=0) r2=1-ssy/ssx;
	}

	double dig2=0.01,dig4=0.0001;
	int mo_p=0; if (nn!=0) mo_p=int(pf/nn+0.5);

	res[0]=long(0.5+bal/dig2)*dig2;
	res[1]=nn;
	res[2]=int(0.5+pf/dig2)*dig2;
	res[3]=int(0.5+drd_pct/dig2)*dig2;
	res[4]=mo_p;
	res[5]=int(0.5+r2/dig4)*dig4;
	res[6]=bal_p;
	res[7]=long(0.5+drd/dig2)*dig2;
	res[8]=nnd1;
	res[9]=nd1;
	res[10]=nnd2;
}
//---------------------------------------------------------------------------
void af_hst(double &hstf[],int sizehf)
{
	for (int i=0; i<sizehf; i++)
	for (int j=0; j<7; j++)
		hstf[j+i*7]=hst_g[j+i*7];
}
//---------------------------------------------------------------------------
void af_arrd(double &arrd1f[],int &arrd2f[],int &ad[])
{
	int sized1=ad[0],nd1=ad[1];
	int sized2=ad[2],nd2=ad[3];
	
	for (int i=0; i<sized1; i++)
	for (int j=0; j<nd1; j++)
		arrd1f[j+i*nd1]=arrd1_g[j+i*nd1];
   
   for (int i=0; i<sized2; i++)
	for (int j=0; j<nd2; j++)
		arrd2f[j+i*nd2]=arrd2_g[j+i*nd2];
}
//---------------------------------------------------------------------------

